﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
'#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	'My 2048
	Private PnlApplication As Panel
	Private grid(4, 4), score, highScore, moveCount As Int
	Private LblScore, LblHighScore, LblMoveCount As Label
	Private BtnUp, BtnDown, BtnRight, BtnLeft As Button
	Private startX, startY As Float
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")

	'Version 1.0 - 2024/08/02

	LoadHighScore
	InitializeGame
End Sub


#Region 2048
Sub InitializeGame
	' Initialize the grid with zeros
	For i = 0 To 3
		For j = 0 To 3
			grid(i, j) = 0
		Next
	Next
	score = 0
	moveCount = 0
	UpdateScoreLabel
	' Add two new tiles to start the game
	AddNewTile
	AddNewTile
	' Draw the initial grid
	DrawGrid
End Sub

Sub AddNewTile
	' Create a list to store empty spots
	Dim emptySpots As List
	emptySpots.Initialize
	' Find all empty spots in the grid
	For i = 0 To 3
		For j = 0 To 3
			If grid(i, j) = 0 Then
				emptySpots.Add(Array As Int(i, j))
			End If
		Next
	Next
	' If there are empty spots, add a new tile
	If emptySpots.Size > 0 Then
		Dim randomSpot As Int = Rnd(0, emptySpots.Size)
		Dim position() As Int = emptySpots.Get(randomSpot)
		' 90% chance of 2, 10% chance of 4
		grid(position(0), position(1)) = IIf(Rnd(0, 100) < 90, 2, 4)
	End If
End Sub

Sub DrawGrid
	Dim tileSize As Int = 90dip
	Dim spacing As Int = 5dip
	Dim gridSize As Int = 4 * tileSize + 3 * spacing
	' Calculate starting positions to center the grid horizontally
	startX = (PnlApplication.Width - gridSize) / 2
	startY = 50dip
	For i = 0 To 3
		For j = 0 To 3
			Dim tile As B4XView = xui.CreatePanel("")
			Dim lbl As Label
			lbl.Initialize("")
			lbl.Text = IIf(grid(i, j) = 0, "", grid(i, j))
			lbl.TextColor = xui.Color_Black
			lbl.Color = GetTileColor(grid(i, j))
			lbl.Gravity = Gravity.CENTER
			lbl.TextSize = 24
			tile.AddView(lbl, 0, 0, tileSize, tileSize)
			' Calculate position for each tile
			Dim tileX As Int = startX + j * (tileSize + spacing)
			Dim tileY As Int = startY + i * (tileSize + spacing)
			PnlApplication.AddView(tile, tileX, tileY, tileSize, tileSize)
		Next
	Next
End Sub

Sub GetTileColor(value As Int) As Int
	' Return color based on tile value
	Select value
		Case 2  : Return xui.Color_RGB(238, 228, 218)
		Case 4  : Return xui.Color_RGB(237, 224, 200)
		Case 8  : Return xui.Color_RGB(242, 177, 121)
		Case 16 : Return xui.Color_RGB(245, 149, 99)
		Case 32 : Return xui.Color_RGB(246, 124, 95)
		Case 64 : Return xui.Color_RGB(246, 94, 59)
		Case 128, 256, 512, 1024, 2048: Return xui.Color_RGB(237, 207, 114)
		Case Else : Return xui.Color_White
	End Select
End Sub

Sub ButtonNew_Click
	InitializeGame
End Sub

Sub CheckGameOver
	' Check if there are any possible moves left
	For i = 0 To 3
		For j = 0 To 3
			If grid(i, j) = 0 Then Return
			If i < 3 And grid(i, j) = grid(i + 1, j) Then Return
			If j < 3 And grid(i, j) = grid(i, j + 1) Then Return
		Next
	Next
	' If no moves are possible, game over
	xui.MsgboxAsync("Total moves: " & moveCount & CRLF & "Score: " & score & CRLF & CRLF & "High score: " & highScore, "GAME OVER")
End Sub

Sub MoveLeft
	For i = 0 To 3
		Dim row(4) As Int
		Dim index As Int = 0
		For j = 0 To 3
			If grid(i, j) <> 0 Then
				row(index) = grid(i, j)
				index = index + 1
			End If
		Next
		For j = 0 To 2
			If row(j) = row(j + 1) And row(j) <> 0 Then
				row(j) = row(j) * 2
				score = score + row(j)
				row(j + 1) = 0
			End If
		Next
		index = 0
		For j = 0 To 3
			If row(j) <> 0 Then
				grid(i, index) = row(j)
				index = index + 1
			End If
		Next
		For j = index To 3
			grid(i, j) = 0
		Next
	Next
	moveCount = moveCount + 1
End Sub

Sub MoveRight
	For i = 0 To 3
		Dim row(4) As Int
		Dim index As Int = 3
		For j = 3 To 0 Step -1
			If grid(i, j) <> 0 Then
				row(index) = grid(i, j)
				index = index - 1
			End If
		Next
		For j = 3 To 1 Step -1
			If row(j) = row(j - 1) And row(j) <> 0 Then
				row(j) = row(j) * 2
				score = score + row(j)
				row(j - 1) = 0
			End If
		Next
		index = 3
		For j = 3 To 0 Step -1
			If row(j) <> 0 Then
				grid(i, index) = row(j)
				index = index - 1
			End If
		Next
		For j = index To 0 Step -1
			grid(i, j) = 0
		Next
	Next
	moveCount = moveCount + 1
End Sub

Sub MoveUp
	For j = 0 To 3
		Dim column(4) As Int
		Dim index As Int = 0
		For i = 0 To 3
			If grid(i, j) <> 0 Then
				column(index) = grid(i, j)
				index = index + 1
			End If
		Next
		For i = 0 To 2
			If column(i) = column(i + 1) And column(i) <> 0 Then
				column(i) = column(i) * 2
				score = score + column(i)
				column(i + 1) = 0
			End If
		Next
		index = 0
		For i = 0 To 3
			If column(i) <> 0 Then
				grid(index, j) = column(i)
				index = index + 1
			End If
		Next
		For i = index To 3
			grid(i, j) = 0
		Next
	Next
	moveCount = moveCount + 1
End Sub

Sub MoveDown
	For j = 0 To 3
		Dim column(4) As Int
		Dim index As Int = 3
		For i = 3 To 0 Step -1
			If grid(i, j) <> 0 Then
				column(index) = grid(i, j)
				index = index - 1
			End If
		Next
		For i = 3 To 1 Step -1
			If column(i) = column(i - 1) And column(i) <> 0 Then
				column(i) = column(i) * 2
				score = score + column(i)
				column(i - 1) = 0
			End If
		Next
		index = 3
		For i = 3 To 0 Step -1
			If column(i) <> 0 Then
				grid(index, j) = column(i)
				index = index - 1
			End If
		Next
		For i = index To 0 Step -1
			grid(i, j) = 0
		Next
	Next
	moveCount = moveCount + 1
End Sub

Private Sub BtnUp_Click
	MoveUp
	AfterMove
End Sub

Private Sub BtnDown_Click
	MoveDown
	AfterMove
End Sub

Private Sub BtnLeft_Click
	MoveLeft
	AfterMove
End Sub

Private Sub BtnRight_Click
	MoveRight
	AfterMove
End Sub

Private Sub AfterMove
	AddNewTile
	DrawGrid
	UpdateScoreLabel
	' Check if current score is higher than high score
	If score > highScore Then
		highScore = score
		UpdateHighScoreLabel
		SaveHighScore
	End If
	CheckGameOver
	' Update labels
	LblMoveCount.Text = "Moves: " & moveCount
	LblScore.Text = "Score: " & score
End Sub

Private Sub LoadHighScore
	If File.Exists(File.DirInternal, "2048.txt") Then
		highScore = File.ReadString(File.DirInternal, "2048.txt")
	Else
		highScore = 0
	End If
	UpdateHighScoreLabel
End Sub

Private Sub SaveHighScore
	File.WriteString(File.DirInternal, "2048.txt", highScore)
End Sub

Private Sub UpdateScoreLabel
	LblScore.Text = "Score: " & score
End Sub

Private Sub UpdateHighScoreLabel
	LblHighScore.Text = "High score: " & highScore
End Sub
#End Region
